﻿namespace Hotline.Share.Dtos.Order
{
    public class ComplementOrderDto
    {
        public string Id { get; set; }

        public string OrderId { get; set; }

        /// <summary>
        /// 工单
        /// </summary>
        public OrderDto Order { get; set; }

        /// <summary>
        /// 补充意见
        /// </summary>
        public string Opinion { get; set; }

        /// <summary>
        /// 补充人员
        /// </summary>
        public string? SupplyName { get; set; }

        /// <summary>
        /// 补充部门
        /// </summary>
        public string? SupplyOrg { get; set; }

        /// <summary>
        /// 补充时间
        /// </summary>
        public DateTime? SupplyTime { get; set; }

        /// <summary>
        /// 工单编号
        /// </summary>
        public string? No { get; set; }

        public string? Title { get; set; }
    }

    public class ComplementOrderCopDto : ComplementOrderDto
    {
        public string? OperationType { get; set; }

        public string? OperationTypeName => OperationType == "0" ? "编辑" : OperationType == "1" ? "删除" : "";

        /// <summary>
        /// 操作时间
        /// </summary>
        public DateTime? CreationTime { get; set; }

        /// <summary>
        /// 操作人
        /// </summary>
        public string? CreatorName { get; set; }
    }

    public class ComplementOrderCopyDetailDto
    {
        /// <summary>
        /// 工单编号
        /// </summary>
        public string? No { get; set; }

        /// <summary>
        /// 工单标题
        /// </summary>
        public string? OrderTitle { get; set; }

        /// <summary>
        ///姓名
        /// </summary>
        public string? UserName { get; set; }

        /// <summary>
        /// 部门
        /// </summary>
        public string? OrgName { get; set; }

        /// <summary>
        /// 
        /// </summary>
        public DateTime? SupplyTime { get; set; }

        /// <summary>
        /// 补充意见
        /// </summary>
        public string Opinion { get; set; }

        /// <summary>
        /// 操作人
        /// </summary>
        public string? OperationName { get; set; }

        /// <summary>
        /// 操作时间
        /// </summary>
        public DateTime? OperationTime { get; set; }
    }

    public class ComplementOrderCopyDetailListDto
    {
        public ComplementOrderCopyDetailDto NewData { get; set; }

        public ComplementOrderCopyDetailDto OldData { get; set; }
    }
}
