﻿using Hotline.Exams.Base;
using SqlSugar;
using System.ComponentModel;

namespace Hotline.Exams.ExamManages
{
    /// <summary>
    /// 线下考试统计
    /// </summary>
    [Description("线下考试统计")]
    public class ExamOfflineExamAnalysis: ExamBusinessEntity
    {
        /// <summary>
        /// 参考人员
        /// </summary>
        [SugarColumn(ColumnDescription = "参考人员")]
        [Description("参考人员")]
        public string UserName { get; set; }

        /// <summary>
        /// 部门名称
        /// </summary>
        [SugarColumn(ColumnDescription = "部门名称")]
        [Description("部门名称")]
        public string DepartmentName { get; set; }

        /// <summary>
        /// 考试标题
        /// </summary>
        [SugarColumn(ColumnDescription = "考试标题")]
        [Description("考试标题")]
        public string ExamName { get; set; }

        /// <summary>
        /// 考试总分
        /// </summary>
        [SugarColumn(ColumnDescription = "考试总分")]
        [Description("考试总分")]
        public int TotalScore { get; set; }

        /// <summary>
        /// 合格分数
        /// </summary>
        [SugarColumn(ColumnDescription = "合格分数")]
        [Description("合格分数")]
        public int CutoffScore { get; set; }

        /// <summary>
        /// 考试分数
        /// </summary>
        [SugarColumn(ColumnDescription = "考试分数")]
        [Description("考试分数")]
        public int Score { get; set; }

        /// <summary>
        /// 考试开始时间
        /// </summary>
        [SugarColumn(ColumnDescription = "开始时间")]
        [Description("开始时间")]
        public DateTime StartTime { get; set; }

        /// <summary>
        /// 考试结束时间
        /// </summary>
        [SugarColumn(ColumnDescription = "考试结束时间")]
        [Description("结束时间")]
        public DateTime? EndTime { get; set; }
    }
}
